#include <iostream>
#include <string>
using namespace std;

class Date {
    friend ostream & operator<<(ostream &, Date);
public:
    Date():month(0), day(0), year(0){}
    Date(int m, int d, int y):month(m), day(d), year(y) {}
    Date(const Date &cd):month(cd.month), day(cd.day), year(cd.year) {}
private:
    int month;
    int day;
    int year;
};

ostream & operator<<(ostream &out, Date d)
{
    out << d.month << "/" << d.day << "/" << d.year;
}

template <class T>
void printArray(const T *, const int);

int main()
{
    int intarr[] = {5, 4,3, 2, 1};
    float floatarr[] = {3.1415, 2.71828};
    string strarr[] = {"Mamamia", "Onomatopoeia", "Cassiopeia"};
     Date darr[2] = {Date(8,23,1962), Date(5,11,1970)};

    printArray(intarr, 5);
    printArray(floatarr, 2);
    printArray(strarr, 3);
    printArray(darr,2);
}

template <class T>
void printArray(const T*arr, const int num_elem)
{
    int i;
    for (i=0; i < num_elem; i++)
        cout << arr[i] << " ";
    cout << endl;
}

